local pLoad = {}
local tiles = 1
local chunkWidth = 32
local seed = love.math.random(1, 1000000)
local octaves = 10

function pLoad.startup()
  engine.system.chunk_camera.setup()
  engine.system.chunk_camera.newMap(tiles, chunkWidth, seed, octaves)
  pLoad.ui = engine.ui.window_manager:new()
  pLoad.ui:add("editor", engine.prefab.planet_editor:new("P Edit", engine.screenWidth - 300, 0, 300, engine.screenHeight, "standard_container", "standard_container_hover", {255,255,255,255}, true))
end

function pLoad.resize(w, h)
  engine.system.chunk_camera.resize(w, h)
  pLoad.ui:closeWindow("editor")
  pLoad.ui:setSize(w, h)
  pLoad.ui:add("editor", engine.prefab.planet_editor:new("P Edit", engine.screenWidth - 300, 0, 300, engine.screenHeight, "standard_container", "standard_container_hover", {255,255,255,255}, true))
end

function pLoad.keyPressed(k)
  engine.system.chunk_camera.keyPressed(k)
end

function pLoad.mousePressed(x, y, b)
  if pLoad.ui:mousePressed(x, y, b) then return end
end

function pLoad.mouseReleased(x, y, b)
  if pLoad.ui:mouseReleased(x, y, b) then return end
end

function pLoad.wheelMoved(x, y, s)
  if pLoad.ui:wheelMoved(x, y, s) then return end
  engine.system.chunk_camera.wheelMoved(x, y, s)
end

function pLoad.update(dt)
  engine.system.chunk_camera.update(dt)
  pLoad.ui:updateMaster(dt)
end

function pLoad.draw()
  engine.system.chunk_camera.draw()
  pLoad.ui:draw()
end

return pLoad