local strength = 255
local chunk = {}

function chunk.new(x, y, chunkWidth, seed, octaves, texture, heightMod, edges, dropoff)
  local ch = {x = x, y = y, terrain = {},}
  local inc = 1 / chunkWidth
  local centerx = chunkWidth / 2
  local centery = centerx
  for cy = 1, chunkWidth do
    ch.terrain[cy] = {}
    for cx = 1, chunkWidth do
      local height = 0
      local px = x + (cx * inc)
      local py = y + (cy * inc)
      local landValue = 0
      local treeValue = 0
      local modifier = 1
      local distX = (cx - centerx)
      local distY = (cy - centery)
      local distFromCenter = math.sqrt((distX * distX) + (distY * distY)) / centerx
      for i = 1, octaves do
        landValue = landValue + (modifier * love.math.noise(i * px, i * py, seed))
        treeValue = treeValue + (modifier * love.math.noise(i * px, i * py, seed * 10))
        modifier = modifier * .5
      end
      height = (((landValue / octaves) + heightMod) * (1 -(edges * distFromCenter ^ dropoff))) * strength
      for i = #texture, 1, -1 do
        if height < texture[i].height then
          tile = i
        end
      end
      if tile == 1 then
        height = texture[1].height
      end
      ch.terrain[cy][cx] = {
        tile = tile,
        height = height,
        tree = (treeValue / octaves) * strength
      }
    end
  end
  return ch
end

function chunk.render()
  
end

return chunk